          Changelog for the ZDaemon Launcher
          ==================================

          Please Note: The versions below
          that are referenced are those that
          were set for the ZDaemon Launcher;
          they may not necessarily match up
          to the release on the referenced
          dates; for the most part this only
          seems to apply for the 1.05 Beta
          releases (which appear to relate
          to their associated RC releases
          for the client/server components).

1. 1.05 Beta 2 release (2003-10-05)
-----------------------------------------------------------------------
 1. Implemented the fetching of avatars from the net and the decoding
    of jpeg files.

 2. The Stats dialog is now a proper child of the player list dialog;
    this prevents potential problems that could happen if you switched
    to the rest of zlauncher while the stats window was still open.

 3. Static linking of mfc and msvcrt libraries.

 4. Got rid of the hawknl and pthreadvce libraries. At this point, no
    DLLs at all are needed.

 5. Got rid of nstamp.txt; the timestamp is saved in the internet
    cache.

 6. Fixed the tab order in the login dialog. After the password it
    should go to the "remember password" check box and then to the
    login button.

 7. Got rid of all user-specific avatars; they are fetched from the net
    when needed.
-----------------------------------------------------------------------

2. 1.05 Beta 3 release (2003-10-10)
-----------------------------------------------------------------------
 1. Enabled the addition of multiple custom servers and their display
    together with the other servers.

 2. Changed a bit the short-long filename conversions to avoid
    modifying the plain filename of the wad files; otherwise, we would
    be incompatible with the wad verification process.

 3. Improved the display of multiple pwads.

 4. Added a net address column.

 5. Enabled the rearrangement of columns by dragging their headers.

 6. Got rid of the level column in the player list (on the lower part
    of the main screen); it can be (and is) so trivially circumvented,
    that it often reports misleading data.

 7. Enabled the display of player statistics by a double-click on the
    player list on the lower part of the screen.

 8. Moved the command to display the player list (which was bound to
    the left-click) to the selection change event (eg., you can do it
    by moving the selection bar with the cursor keys).

 9. Moved the server refresh command (which was bound to the right-
    click) to the left-click.

10. Enabled the right-click to display a context menu for the given
    server.

11. Reorganized a bit the menus.

12. Implemented various sorting schemes on the server list.

13. Improved the network code to produce more reliable ping values and
    reduce packet dropping when querying all servers.

14. Added the F5 and Ctrl+F5 accelerators for the "Refresh All" and
    "Requery Master" commands.

15. Improved the server information dialog to show the meaning of
    dmflags and dmflags2 and enable visits to the website or
    sending of mail by clicking on the relevant info.

16. Reads the additional teamplay and other server variables and
    displays more useful information. Among other things, it also
    displays an extra column indicating if a server is password
    protected.

17. Reads optional wads from the server and acts accordingly upon
    launching a new game (ie., it will not stop if an optional
    wad is missing).

18. Integrated getwad with zlauncher; if you try to launch a game and a
    required wad is missing, you will be prompted to search for the
    file. If you answer "Yes", zlauncher will run getwad in order to
    locate the file. If everything goes well, then the launch will
    continue without further prompts. Getwad has been converted to a
    static library, so we still don't need any DLL.

19. When the program was set to compile using the static libraries, we
    would get linker errors about the functions new() and delete()
    being duplicated in nafxcw.lib (MFC static libraries) and
    libcmt.lib (C/C++ multi-threaded runtime libraries). This looks
    like a design limitation of VC++; Microsoft recommends to use the
    DLL version of MFC and to ignore libcmt.lib completely. This
    however results in the program requiring mfc42.dll, msvcrt.dll and
    msvcp60.dll which I find unacceptable. Therefore, I did a rather
    dirty trick; I made a copy of libcmt.lib (called hslibcmt.lib) and
    I removed the functions new() and delete() from that copy. Then I
    instructed VC++ to (a) use static MFC libraries, (b) ignore
    libcmt.lib and (c) use hslibcmt.lib. This works fine, but it's
    still a pretty weird trick. One of its bad side effects is that
    it's very much dependent on VC++ 6, but so is the original problem
    too. If Microsoft fixes the problem in later versions of the
    compiler, then we will not need this trick any more; I'm
    documenting it so that other developers understand what's going on
    with that library (for example, don't try to use that library on
    another compiler or another version of VC++).
-----------------------------------------------------------------------

3. 1.05 Beta 4 release (2003-10-15)
-----------------------------------------------------------------------
 1. Uses a std. ini file instead of a binary cfg file. This will
    facilitate the deployment of a setup program in the future.

 2. Saves window position, layout, column order.

 3. When refreshing a server, it clears the ping value so that we
    always know if a server has been refreshed or not.

 4. Shows the server info in blue when there are players on it.

 5. Improved the wad directory dialog to interrupt the automatic search
    properly and to specify the download directory for files fetched
    from the Net.

 6. Fixed a small problem where the "There are important news..."
    message would pop up behind the main window.

 7. Improved the speed of the server information display and reduced
    dropped server responses.

 8. Enabled the XP look (on Windows XP of course).

 9. Added a new command in the Help menu to go to the news page.

10. Added a "key" icon that appears on password-protected servers.

11. Added server-specific passwords.

12. Added an indicator of the total number of servers on the
    status line.

13. Improved the reliability of the net code; it (hopefully) avoids
    crashes or other bugs due to simultaneous modification of variables
    by different threads. You should be able to click on the
    "refresh-all" or "query-master" buttons as many times and as often
    as you like without any ill effects.

14. Disabled the refreshing of a single server with a single left-click
    on its name; it was too annoying.
-----------------------------------------------------------------------

4. 1.05 Beta 5 release (2003-10-18)
-----------------------------------------------------------------------
 1. Added a progress bar about the refresh process on the status line.

 2. Got rid of all Easter eggs, cheats, etc. The executable's size was
    reduced by about 450K.

 3. Added a button in the player stats dialog to send the player to the
    avatar mgt. web page. This button is available only for our own
    profile and only when we have reached the last standard avatar
    (ie., God).

 4. Disabled the close button during info update in the playerstats
    dialog.

 5. Added extra checks on shutdown to ensure that all threads are
    closed. If the user tries to exit the program while a refresh is
    active, the program will refuse to exit (so the user can retry in 5
    seconds).

 6. Added a command in the Stats submenu to view our own stats quickly.

 7. Fixed a problem with spaces in iwad paths.

 8. Added some avatar caching; the avatars are cached for the duration
    of the zlauncher session; they are automatically deleted upon exit.
    This caching occurs on top of normal windows caching, so the user
    is still responsible for reasonable cache settings under Windows.

 9. Added a new command in the help submenu to bring you to the ZDaemon
    fora.

10. Simplified a bit the help submenu; there is no real point in having
    an "On the web" sub-submenu when the program only operates online.
-----------------------------------------------------------------------

5. 1.05 Beta 6 release (2003-10-18)
-----------------------------------------------------------------------
 1. Fixed a stupid bug of me that resulted in a crash when you fetched
    a wad manually.
-----------------------------------------------------------------------

6. 1.05 Beta 7 release (2003-10-18)
-----------------------------------------------------------------------
 1. Changed the threshold for enabling custom avatars from 11500 to
    3100 points. The new threshold corresponds to the one between the
    second and third standard (experience-based) avatars.
-----------------------------------------------------------------------

7. 1.05 Beta 8 release (2003-10-19)
-----------------------------------------------------------------------
 1. Switched the master port from 15200 to 15300.
-----------------------------------------------------------------------

8. 1.05.03 release (2003-11-05)
-----------------------------------------------------------------------
 1. Updated Zlauncher to show detailed version and OS info in the
    server info dialog.

 2. Enabled the copying of the server IP address/port by clicking on it
    in the server info dialog.
-----------------------------------------------------------------------

9. 1.05.04 release (2003-12-09)
-----------------------------------------------------------------------
 1. Overhauled the credits dialog; the text quality and scrolling speed
    are a bit better and there is no problem if you switch to another
    window and then back to the credits dialog.

 2. Fixed a small bug in the experience progress bar in the player info
    dialog; the bug would happen only with large experience values
    (65300 and above).

 3. Removed the "Master Refresh" command; this operation is now done
    with the "Refresh All" command.

 4. Enabled the use of more custom avatars.

 5. Fixed a signed/unsigned bug when a server listens to a port higher
    than 32767.

 6. Updated getwad to fetch the search list from the web; also made
    several other minor search improvements to getwad.

 7. Enabled the search of IWADs through getwad.

 8. Added the %DATE%, %TIME% and %WAD% special sequences in the extra
    parameter string passed to zdaemon. These sequences expand to the
    current date (YYYYMMDD), time (HHMMSS) and wad (WAD1_WAD2_WAD3...)
    respectively. The %WAD% expansion consists of all non-optional
    PWADs: no IWAD or optional PWADs are included.

 9. Added a "Hide Unreachable Servers" option to remove non-responding
    servers from server list.

10. Modified the launcher so that it uses the ini file and zdaemon.exe
    from its own directory instead of the current directory.

11. Added a "Record Demo" to the "Server" menu and the context submenu.
    It prompts you for a demo filename and then launches a game with
    the "-netrecord" option.

12. Fixed a toolbar problem; it sometimes switched to "text label mode"
    on video mode changes and some other events.
-----------------------------------------------------------------------

10. 1.05.05 release (2004-01-23)
-----------------------------------------------------------------------
 1. Fixed a small toolbar problem: it would display a small part near
    the left border as transparent.

 2. Added autorefresh and auto-relogin options. If activated, they
    occur every 10 minutes.

 3. Enforced the current sorting order after you refresh all servers
    (or they autorefresh).

 4. Fixed a small repainting problem in the credits dialog.

 5. Marked the sorting column with a slightly different background
    color.

 6. Added persistence to the sorting method.

 7. Added a demo directory setting; the recorded demo files will be
    stored there by default.

 8. Added a "play demo" command. It prompts for the demo filename and
    wad names and runs ZDaemon.

 9. Fixed a race condition in the closing of the login dialog.

10. Added support for the upcoming CTF mode. For team games (Team DM
    and CTF) it also displays the team score next to the team name on
    the bottom list.

11. Added a display for the total number of players and bots on the
    status line.

12. Improved the color selection scheme for the populated servers.

13. Added old-school server settings detection; such servers are
    indicated by a different (golden) icon.

14. Added the display of each server's country and flag.

15. Added support for a new value of the trusted flag (2) returned by
    the master which indicates that the particular server reports
    detailed stats apart from experience.

16. Added more fields in the Server Details dialog to account for new
    information such as gravity and air control values.

17. Added 2 new menu commands to display the experience and stats web
    pages.

18. Added a new IWAD column to the server display page.

19. Added a (rather hidden) traceroute command: it is invoked by
    clicking the right mouse button in conjunction with the Control key
    on a server. The command invocation is deliberately cryptic as it
    is not of much use to the general audience of the program. The
    traceroute operation is performed by a simple batch file that runs
    the windows "tracert" command. You can also use any other similar
    program you like, provided that:
     a. You add an entry like:
              traceroute=c:\progra~1\some_prog\traceroute.exe
        in the "Misc" section of zlauncher.ini. Note that the specified
        path may NOT contain spaces; if it does, then use the short
        version of the pathname (e.g., use "C:\progra~1\..." instead of
        "C:\Program Files\..." ).
     b. The specified program must accept an ip address on its command
        line.

20. Added the new TOS document.

21. Implemented the automatic update of the ip/country database through
    the web.

22. Added commands to specify the color of the populated servers as
    well as the sorting column background.

23. Added a help page describing the various icons on the far left side
    of the server list. It is accessible from the Help submenu.

24. Modified a bit the player list at the bottom half of the screen to
    always sort the players by team, frags and name (in that order).
    It also updates the column label for kills/frags/points depending
    on the nature of the game (Coop --> kills, CTF --> points, DM and
    Team DM --> frags).

25. Added a buddy list with a visual notification of servers containing
    buddies, as well as as optional audio notification when the online
    status of a buddy changes. There are actually 3 different audio
    clips for various conditions: the first one is when one or more
    buddies connect, the second one is when one or more buddies
    disconnect, and the third one is when there are both connections
    and disconnections. Given that the connection status of the buddies
    gets updated when you refresh the servers, I set the auto-refresh
    timer to 5 minutes (instead of 10); this should work better with
    the buddy list. I also added a context menu to the player list on
    the lower half of the screen. The menu has commands to add/remove
    the given player from your buddy list.

26. Added Add/Remove Buddy buttons to the player list dialog.

27. Added a second tab with the buddy list contents separated into
    online and offline groups. There is also a context menu with
    applicable commands for each buddy.
-----------------------------------------------------------------------

11. 1.05.06 release (2004-02-29)
-----------------------------------------------------------------------
 1. Replaced the ip/country database files by a DLL; it's faster and
    smaller.

 2. Fixed a deadlock occuring at the closing of the Custom Server
    dialog.
-----------------------------------------------------------------------

12. 1.05.07 release (2004-03-16)
-----------------------------------------------------------------------
 1. Minor ip/country-related improvements.

 2. Added a toolbar button to manage the buddy list.
-----------------------------------------------------------------------

13. 1.06.04 release (2004-07-23)
-----------------------------------------------------------------------
 1. Added different player icons depending on whether it's a bot, a
    spectator or a normal player. The icon for normal players uses the
    team color, or green for DM.

 2. Added support for the display of each player's country.

 3. Added support for the new dmgflags2 regarding the preferred weapon
    order and the target name display.
-----------------------------------------------------------------------

14. 1.06.07 release (2004-09-11)
-----------------------------------------------------------------------
 1. Added new icons for bot servers.

 2. Removed the admin submenu for non-admins.

 3. Blocked the automatic refresh of the servers when the launcher
    window is active or when getwad is downloading a wad.   

 4. New login screen image courtesy of UrHaSh(OS).
-----------------------------------------------------------------------

15. 1.06.08 release (2005-03-04)
-----------------------------------------------------------------------
 1. Implemented an IRC client connecting to a dedicated zdaemon
    channel.

 2. Added new tabs for the ZDaemon home page and forum.

 3. Added user-definable tabs with Web content.

 4. Added automatic detection of LAN servers.

 5. A click of the middle button (or the left+right buttons) on a
    server triggers a refresh of that server.

 6. Added a Single Player mode launcher.

 7. Added an offline mode so people can play SP or join LAN servers
    without logging in to the master.

 8. Added a server query speed setting so you can fine tune it to your
    connection's speed.

 9. Implemented IRC buddies and integrated them with the in-game ones.

10. Added a command to start ZSLLite.
-----------------------------------------------------------------------

16. 1.06.09 release (2005-03-22)
-----------------------------------------------------------------------
 1. Added an exit confirmation option.

 2. Added automatic setting of the away status in IRC while playing a
    game.

 3. Fixed a buffer overflow problem when player profiles contained more
    than 255 characters.
-----------------------------------------------------------------------

17. 1.07rc2 release (2005-07-07)
-----------------------------------------------------------------------
 1. The Gold Team is now White.

 2. New DMFLAGS/DMFLAGS2 in the Single-Player Launcher

 3. Adjustment to the OS definition for the golden bullet.s

 4. Added support for Freedoom and FreeDM for SP and demos.
-----------------------------------------------------------------------

18. 1.08.03 release (2006-12-11)
-----------------------------------------------------------------------
 1. Added an option about the look of the country flags.

 2. Reorganized the settings/preferences submenus.

 3. Enabled multiple languages (utf-8) in server banners and player
    profiles.

 4. Major changes to ZRC (check its change log: the changes are far too
    many to list here).

 5. Implemented a tab with favorite servers.

 6. Added an option about the font used by the launcher.

 7. Added more enabling/disabling checks to the gui to visually
    indicate when some operations are not available (eg., while
    refreshing the server list or offline).

 8. New %USER% macro available for demo filenames.

 9. Implemented user-defined filtering based on various criteria. Each
    filtered view appears in its own tab and when you hit the
    "refresh all" button (or F5) it refreshes only the servers in the
    current tab.

10. The toolbar icons are now user-selectable.
-----------------------------------------------------------------------

19. 1.08.06 release (2008-05-26)
-----------------------------------------------------------------------
 1. Implemented new launcher info packet covering all the functionality
    needed for 1.09

 2. Sometimes the server would report phantom players to the launcher.
    Should be fixed now.

 3. The launcher has been upgraded to understand and handle alternate
    wads properly. It will prompt you when a selection has to be made
    and it will remember your choice.
-----------------------------------------------------------------------

20. 1.08.07 release (2008-06-03)
-----------------------------------------------------------------------
 1. The launcher would not properly erase the contents of the death
    column when clicking on a server that didn't show deaths.
-----------------------------------------------------------------------

21. 1.08.08 release (2009-07-16)
-----------------------------------------------------------------------
 1. The launcher can now patch IWADs automatically courtesy of
    Doom2pro's IWAD patcher: noone should ever need to do it manually.

 2. The launcher now handles demos with spaces in the filename.

 3. New searching function in the launcher. You can search for strings
    in the server name or for WADs. Searching is done in full unicode
    (useful for server names) even under Win9x.

 4. The splashfactor cvar is now sent to the launcher so that one can
    setup launcher filters for RJ servers.

 5. Implemented a new game mode called "Survival"; it's basically coop
    with limited lives. The amount of lives is set by the "maxlives"
    cvar. Once a player's deathcount exceeds maxlives, he becomes a
    spectator and his IP address is blocked from joining till the end
    of the round. If everyone becomes a spectator (ie,. failure), then
    the map resets. Contrary to other modes, spectators who used to be
    players can vote (ie they're considered as players for voting
    purposes). Team damage is forced to zero (and even telefrags dont'
    affect the deathcount) to avoid "unpleasantries". Survival is also
    playable in SP mode (from the SP launcher).
-----------------------------------------------------------------------

22. 1.08.08a release (2010-07-13)
-----------------------------------------------------------------------
 1. Added the \s escape sequence to the IRC away messages to indicate
    the server where one plays.

 2. Added "Copy ZDS Link" to the server context menu.

 3. Changes made to run the IWAD Patcher as a DLL.
-----------------------------------------------------------------------

23. 1.09b21 release (2011-07-16)
-----------------------------------------------------------------------
 1. Hide the "Edit / Convert Demos..." setting if the ZDDemotool.exe is
    not found.

 2. Support for the new Double Domination game mode.

 3. Enable ZDS links to function with a hostname if one is specified
    instead of an IP address.

 4. The TNT and Plutonia IWADs are now handled by the IWAD Patcher.

 5. Added more server query speed settings to the launcher resulting in
    faster server refreshes.

 6. Implemented an update mechanism into the launcher; it can download
    and install all mandatory and optional updates with a minimum of
    effort from the user's part.

 7. Support added for the latest DMFLAGS and DMFLAGS2:
    * DMFLAGS:  "Classic Death Camera", "Instagib"
    * DMFLAGS2: "Classic Blast Physics"

 8. Adjustments made to avoid refreshing the server list while the
    ZDaemon Client is running.

 9. Wine fixes and saving/restoring of the window state for the
    launcher.

10. Improved server query speed for the launcher, *especially* under
    wine.

11. New 'humans' column in the launcher: useful for sorting servers by
    human clients.
-----------------------------------------------------------------------

24. 1.09b22 release (2011-07-28)
-----------------------------------------------------------------------
 1. Bug fixes related to the auto-update mechanism.

 2. New %BASE% escape sequence; useful for specifying the location of
    various files.

 3. Added instagib as a game style in the filters.

 4. Increased the number of players/clients in the filters.

 5. Improve the Filter submenu to show the filter names.
-----------------------------------------------------------------------

25. 1.09b23 release (2011-07-30)
-----------------------------------------------------------------------
 1. The update dialog in ZLauncher can now produce a list of affected
    files.
-----------------------------------------------------------------------

26. 1.09b24 release (2012-01-27)
-----------------------------------------------------------------------
 1. Added an auto-record option to the launcher.

 2. New server icons.

 3. Extend searching to the server adddresses.

 4. Improved SP launcher and better support of freedoom/blasphemer.

 5. Tooltips implemented on the server list view(s).

 6. Tooltip implementation in the "Detailed Server Info" dialogue has
    been extended to the referenced PWADs. (once they exceed a length
    threshold)

 7. New 'Berserk on Spawn' DMFLAG2.

 8. Tooltips added for the server icons.

 9. Make sure old servers are not reported as having the berserk flag
    on.

10. Faster handling of favorite servers.
-----------------------------------------------------------------------

27. 1.09b25 release (2012-02-03)
-----------------------------------------------------------------------
 1. Improvements made to the "Detailed Server Info" dialogue:
    a) A tooltip is now displayed for overlong and truncated server
       names.
    b) Added a "Game Style" row with associated tooltip; hovering over
       the said tooltip will provide detail behind the mentioned style.
    c) The "Country" reference will now link you to an information for
       the said location. (This doesn't apply to LAN)
    d) Clicking the "IP address" will direct you to a page in order for
       it to be geolocated.

 2. OS classification has been fixed for 1.08.xx servers.

 3. Further improvements made to the "Detailed Server Info" dialogue.

 4. Improved definitions of OS for Heretic/Hexen.
-----------------------------------------------------------------------

28. 1.09b26 release (2012-03-15)
-----------------------------------------------------------------------
 1. Improvments made to the auto-update mechanism.

 2. Added wad sizes to the missing wad prompt.

 3. Improvements made to the Single Player PWAD selection dialogue.

 4. Add filtering to the pwad selection dialog and enable the up/down
    moving of multiple wads.

 5. Converted the demo dialog to use the new pwad selection.

 6. An overhaul of the server icons has taken place.
-----------------------------------------------------------------------

29. 1.09b27 release (2012-05-10)
-----------------------------------------------------------------------
 1. Manual update check implementation. (Help -> Check for Updates)

 2. Presets have been implemented in the Single Player Launcher.

 3. Miscellaneous improvements made to the Single Player Launcher.

 4. Option added for the checking and application of auto updates on
    startup.
-----------------------------------------------------------------------

30. 1.09b28 release (2012-08-31)
-----------------------------------------------------------------------
 1. Bug fix regarding the saving of the width/ordering of the player
    list.

 2. Added support for the KOTH mode.

 3. Clarified the displayed notice for when an update needs to be
    applied on startup.

 4. Added the %GAMETYPE% special sequence in the naming of demos.

 5. Improvements made to the extra command line and demo name prompt
    dialogues.

 6. Support for the new 'Classic Missile Clip' DMFLAG2.

 7. Implemented filtering based on dmflags.

 8. Implemented a default demo name.

 9. Reorganized the demo-related options.

10. Support for ZDL (.zdl) demo playlists.

11. Support for KOTH in the Single Player Launcher.

12. The Login dialogue has been redesigned; it now has 3 tabs:
    - New Account  (Creating a new account)
    - Login        (Logging into an existing account)
    - Play Locally (Specify the name to use while offline; if a name
                    hasn't been specified your ZDaemon name is used)

13. Tooltips have been added to the DMFlags dialogue in the Single
    Player Launcher.

14. Explicitly state altdeath/newdeath in the tooltip info.

15. Improvements made to the GetWAD search process.

16. WAD filename length has been increased from 31 to 63 characters.

17. New base static banner in the Login dialogue.

18. Random banners have been implemented in the login dialogue.

19. Implemented a "Join Password" for servers; this enables anyone to
     connect to a server, but he'll have to supply a password to join
     (play). The password is specified by the "join_password" CVAR on
     both the server and client sides. The launcher can optionally
     prompt for (and remember) such passwords when one connects to the
     server.

20. Fix an issue concerning the retention of stored server passwords.
-----------------------------------------------------------------------

31. 1.09 release (Initial: 2012-09-01)
-----------------------------------------------------------------------
 1. Added support for the ZDaemon Server Wizard.

 -- 2012-09-17 --

 2. Support added for alternative in-game aliases
    (Servers -> In-Game Aliases...). A valid username/password must be
    specified for each alias in order for it to be usable; the alias
    can then be selected via the combobox on the right-hand side of the
    launcher toolbar.

 -- 2012-10-20 --

 3. IWAD Patcher has been updated to account for the BFG IWADs.
-----------------------------------------------------------------------

32. 1.09.01 release (Initial: 2012-11-10)
-----------------------------------------------------------------------
 1. When opening a ZDD demo via the launcher, the launcher checks
    for the presence of the WADs specified in the demo and prompts
    to fetch any missing ones.
-----------------------------------------------------------------------

33. 1.10 release (Initial: 2013-12-23) (Encompasses beta to current)
-----------------------------------------------------------------------
 -- Up to 1.10b01 - 2013-12-23 --

 1. Added the %RNDCOLOR% special sequence for randomising your player's
    color.

 2. Support for the 'Widescreen' DMFLAG.

 3. Correction made to the Server Name tooltip in the "Detailed Server
    Info" dialogue.

 4. Search-related bug fix.

 5. Support for the 'Allow multiple-key bindings' DMFLAG.

 6. Replaced 'OS Jump' with 'Allow Double Jumping' DMFLAG2.

 7. Support for the 'Bright Skins' DMFLAG2.

 8. Single Player Launcher improvements:
    a) Player Class selection for Hexen.
    b) Adaptive Skill labels according to the IWAD.

 9. Enabled the selection of multiple server entries; only certain
    operations can be performed while multiple entries are selected.

10. Improvements made to the status line displaying the number of
    servers, players and bots; it will now also display the total
    number based on the current tab against the global list.

11. Enable relative paths for both WAD and demo directories.

12. GetWAD FTP link improvements.

13. Support for the 'Instant Teleport' DMFLAG3.

14. New area for setting the Video Mode options on the ZDaemon client.

15. Support for the new built-in 'WAD Downloading' functionality from
    the ZServ; when enabled the launcher will be notified about it and
    will make use of the server's download page in order to fetch any
    missing wads.

 -- Up to 1.10b03 - 2015-01-01 --

16. New column showing the server version.

 -- Up to 1.10b09 - 2018-02-12 --

17. Support for the 'Allow chase mode (Coop)' DMFLAG3.

 - 1.10 -
 -- 2018-03-07 --
 
18. Support added for 'Server-side Demos'. The "Server Demo Page..."
    item has been added to the right-click Server pop-up menu.

 -- 2018-04-08 --

19. Support for the 'Infinite Items' DMFLAG3

20. Support for the new 'Duel' game mode (9).

 -- 2018-11-19 --

21. Support for the 'Episode Inventory Reset' DMFLAG3.

 -- 2019-03-20 --

22. Auto-adapt the login and credits screens for higher DPI.

 -- 2019-05-29 --

23. ZLauncher can now become the system-wide handler of the zds://
    protocol.

 -- 2019-07-19 --

24. Maximum number of possible PWADs has been increased from 7 to 15.

 -- 2020-01-03 --

25. Adjustments made to the auto-update mechanism.

26. Fixes made to account for various Win10 quirks.

 -- 2021-09-09 --

27. Default internal font adjusted from "MS Sans Serif" to "Tahoma".
    This fixes an issue concerning missing fonts on Win10 that would
    otherwise prevent certain dialogues from appearing.

28. Fixed an issue that resulted in a custom toolbar image being unset
    on the next start.

 -- 2021-10-29 --

29. Support for the 'Allow spy' DMFLAG3.

 -- 2021-12-19 --

30. Fixed an issue concerning the display of the checkbox-specific
    tooltips in the DMFlags dialogue via the Single Player Launcher.

31. Support for the the following DMFLAGS3:
    - 'Unusual Pickups (DeH)'
    - 'Mismatch Correction (DeH)

32. An automatic refresh will occur on the target server entry upon
    attempting to join.

 -- 2022-03-22 --

33. Modifications made to the display of custom banners in the Login
    dialogue.

 -- 2022-07-11 --

34. Borderless fullscreen (windowed) for primary monitor added.
    It can be enabled in Video Modes or via ZLauncher.

35. DPI-related improvements concerning the server view area(s), fonts
    and page tabs.

36. Text message improvement concerning the setting of a custom toolbar
    image.

37. A constraint has been added to ensure that usage of the %WAD%
    escape sequence won't result in an overlong string of PWADs.

38. HTTPS support in GetWAD. (The libcurl.dll is now required in order
    for HTTPS to function; this component is provided in the setup
    executable or archive; it is also automatically fetched via the
    automatic updates) (HTTPS functionality will not be available if
    the libcurl.dll cannot be found or loaded)

39. Fixes made concerning the splitter in the server view area(s).

 -- 2022-08-10 --

40. The IWAD text in the Detailed Server Info dialogue is now truncated
    and a tooltip generated if it is overlong.

 -- 2022-10-03 --

41. Checking data for validity before saving to avoid writing zero
    values to zlauncher.ini. E.g. rare cases when the server columns
    get erroneous.

 -- 2023-08-30 --

42. Added support for more aspect ratios.

43. Internal improvements made to the WAD directory handling.

44. A Game Template selection menu has been added to the Single Player
    Game area; it will allow you to select a pre-defined template that
    can then be further modified.

45. The "Starting Map" selection menu in the Single Player dialogue
    now accepts custom entries.

 -- 2023-11-21 --

46. Fixed an issue with the server password manager on some systems
    that resulted in a crash during the launch of the client.
    (Thanks go to SuperGustafson9 for helping to narrow down this case)

47. Chex Quest is now a selectable game.

 -- 2023-12-05 --

48. Fixed an obscure bug.

 -- 2024-03-30 --

49. The player/client filters now accept a value up to 100.

 -- 2024-10-28 --

50. The IWADPatcher has been updated to account for later Doom, Doom II,
    Plutonia and TNT versions.

 -- 2025-02-10 --

51. Improvements for flickering tooltip if the screen is to small to
    show all dmflags in Detailed Info.

52. Fixed a condition with the news detection whereas even after an
    entry was removed it would state that "New" announcements were
    detected.

 -- 2025-05-17 --

53. IP2C overhaul.

 -- 2025-09-01 --

54. Miscellaneous underlying fixes.

 -- 2026-05-25 --

55. Built-in Web Browser has been updated, this brings new life to the
    web tab functionality.

56. Tweaks related to the uncommon List Control anomalies that some users
    experience (large icon mode rather than report).
